* Initial Mvebu RFC https://github.com/armbian/build/issues/1426 Signed-off-by: Igor Pecovnik <igor.pecovnik@gmail.com> * mvebu: add missing patches Signed-off-by: Igor Pecovnik <igor.pecovnik@gmail.com> * mvebu: change making u-boot targets to standard way, adjust patches and config Signed-off-by: Igor Pecovnik <igor.pecovnik@gmail.com> * helios4: set default branch to use U-Boot 2018.11 Switch over to U-Boot 2018.11 that has been used for some time in next branch. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: helios4: Enable DEV branch Signed-off-by: Aditya Prayoga <aditya@kobol.io> * u-boot: Add RTC support on Clearfog and Helios4 Added DM driver for mvebu RTC and enable it on Clearfog and Helios4 configuration. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * add boot-marvell.cmd backward compatibility The patches added missing variable that used on boot-marvell.cmd and also adjust the some memory addresses to prevent crash due to usage of fdt_high and initrd_high. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * helios4: Added SPI NOR flash target Build bootable SPI NOR flash image. Change the boot order to USB -> SATA -> MMC Signed-off-by: Aditya Prayoga <aditya@kobol.io> * Restore SPI support on U-Boot 2019.04 * mvebu: kernel: Added Wake-On-GPIO and WoL support The patch set was missing during transition. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * [#1429] SolidRun's ARMADA A388 SOM U-Boot ODT Update Old versions of U-Boot did not configure correctly the ODT on data signals of DDR RAM on SolidRun's ARMADA A388 SOMs. According to SolidRun Knowledge Base, the changes already pushed to mainline U-Boot. But then it was overwritten when Marvell DDR Training Tool updated [URL] https://developer.solid-run.com/knowledge-base/armada-38x-som-u-boot-odt-update/ Signed-off-by: Aditya Prayoga <aditya@kobol.io> * [#1429] mvebu: u-boot: Add revision id for Armada 38x B0 Added patch for SolidRun U-Boot v2018.01 and for Helios4 U-Boot v2018.11 Signed-off-by: Aditya Prayoga <aditya@kobol.io> * clearfog: Added SPI NOR flash target Build bootable SPI NOR flash image. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: clearfog: DEV branch use mainline U-Boot Also move clearfog base patch into its own board folder. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: enable U-Boot uart target Normal MMC image can be used for uart boot using following command: ./tools/kwboot -b u-boot-spl.kwb /dev/ttyUSBX But on Helios4, the SPL failed to continue the booting process if ECC is enabled, so disable it. Since the usage of uart boot is more for rescue/debug, disable autoboot. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: NEXT branch use mainline U-Boot Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: helios4: fix fancontrol related bug during buster testing - On kernel 4.19, cpu thermal sensor changed the name from armada_thermal into f10e4078.thermal. Added this new name to udev rules - Since DEFAULT branch now use kernel 4.14, update fancontrol configuration - Load lm75 kernel module - On kernel 4.19, cpu temp reading about 20 degree C lower, update fancontrol configuration. [URL] https://forum.armbian.com/topic/10214-clearfogpro-possible-change-in-temperature-reporting-between-414next-and-419dev Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: helios4: Override vendor provided fancontrol unit systemd emit following message on dmesg systemd[1]: /lib/systemd/system/fancontrol.service:9: PIDFile= references path below legacy directory /var/run/, updating /var/run/fancontrol.pid \xe2\x86\x92 /run/fancontrol.pid; please update the unit file accordingly. Override and change the value in the unit file to remove the message. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: DEV branch use its own u-boot patch folder The patches are copied over from u-boot-mvebu-next Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: u-boot: Make clearfog model distinction more obvious While at it, also change SerDes LANE4 into USB 3.0 on Clearfog Base. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * lib: Use apt-get install instead of dpkg on install_deb_chroot() dpkg -i does not install dependencies required by the package. This is needed if the BSP package requires other package that is not installed during debootstrap. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * config: mvebu: helios4: Move various tweak to family_tweak_bsp() Various tweak in family_tweaks_s() only applied to SD card image. Move it to family_tweaks_bsp() so it will also included on the BSP package and applied to existing user. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * config: mvebu: helios4: Add /etc/modules to BSP On kernel 4.19, user need to modify the /etc/modules to add lm75 kernel module. Pack the file into BSP so user no longer needed to modify it. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: kernel: Make zbud as built-in module To remove the following error: [ 1.705485] zswap: default zpool zbud not available [ 1.705488] zswap: pool creation failed Signed-off-by: Aditya Prayoga <aditya@kobol.io> * bootscripts: mvebu: Add default value for spi_workaround Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: kernel: Backport armada_thermal changes to 4.14 (#1452) On kernel 4.19, armada_thermal driver has been fixed to address Marvell's Errata #132698 (The changes first appear on LK 4.16). The result is temperature reading is around 20 degree Celsius lower. Currently armbian-motd apply -20C tweak for both LK 4.14 and LK 4.19 which is incorrect. Instead of adding some logic on what condition to apply the tweak, it is better to remove the tweak and patch the kernel instead. Revert commitb3dd4e9("[ mvebu ] Put back Armada temperature tweak in motd") which is part of #1421 solution. [URL] https://forum.armbian.com/topic/10214-clearfogpro-possible-change-in-temperature-reporting-between-414next-and-419dev/ Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: helios4: unified fancontrol config Since LK 4.14 on DEFAULT branch already patched and the temp reading is same as LK 4.19 on NEXT branch, it is no longer needed to separate fancontrol configuration file. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * u-boot: helios4: Remove rev id patch The patch is already applied in helios4 repo, no need to have it in armbian. This revert helios4 part of commit7411c55Signed-off-by: Aditya Prayoga <aditya@kobol.io> * u-boot: clearfog: enable PCIe support and PCIe reset Signed-off-by: Aditya Prayoga <aditya@kobol.io> * u-boot: clearfog: add boot-marvell.cmd backward compatibility The patches added missing variable that used on boot-marvell.cmd and also adjust the some memory addresses to prevent crash due to usage of fdt_high and initrd_high. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu: helios4: tweak regarding temperature setting Make fan speed similar compared to pre-patched armada-thermal. Target PWM value around 70 during idle. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * config: sources: clearfog to use u-boot 2018.01 for NEXT branch This changes also affect Helios4. Moved the shared U-Boot source setting back to Helios4 for NEXT branch. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * config: boards: build Stretch image for Clearfog and Helios4 Also remove DEV from Helios4 CLI_TARGET Signed-off-by: Aditya Prayoga <aditya@kobol.io> * kernel: mvebu-next: Disable access to SPI Flash User need to set spi_workaround=yes to enable SPI Flash access and lost access to internal SATA. Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu-next: adjust kernel config * mvebu-dev: bump to 5.2 and adjust kernel configuraion. Tested for building. * Adjust kernel config, add AUFS Signed-off-by: Igor Pecovnik <igor.pecovnik@gmail.com> * mvebu-next: Adjust kernel config, add debug GPIO Signed-off-by: Aditya Prayoga <aditya@kobol.io> * mvebu-dev: separate Clearfog Base U-boot configuration file and patch Signed-off-by: Aditya Prayoga <aditya@kobol.io>
222 lines
8.2 KiB
Diff
222 lines
8.2 KiB
Diff
diff --git a/scripts/package/builddeb b/scripts/package/builddeb
|
|
index 90c9a8a..3c79b90 100755
|
|
--- a/scripts/package/builddeb
|
|
+++ b/scripts/package/builddeb
|
|
@@ -29,6 +29,27 @@ create_package() {
|
|
# in case we are in a restrictive umask environment like 0077
|
|
chmod -R a+rX "$pdir"
|
|
|
|
+ # Create preinstall and post install script to remove dtb
|
|
+ if [[ "$1" == *dtb* ]]; then
|
|
+ echo "if [ -d /boot/dtb-$version ]; then mv /boot/dtb-$version /boot/dtb-$version.old; fi" >> $pdir/DEBIAN/preinst
|
|
+ echo "if [ -d /boot/dtb.old ]; then rm -rf /boot/dtb.old; fi" >> $pdir/DEBIAN/preinst
|
|
+ echo "if [ -d /boot/dtb ]; then mv /boot/dtb /boot/dtb.old; fi" >> $pdir/DEBIAN/preinst
|
|
+ echo "exit 0" >> $pdir/DEBIAN/preinst
|
|
+ chmod 775 $pdir/DEBIAN/preinst
|
|
+
|
|
+ echo "if [ -d /boot/dtb-$version.old ]; then rm -rf /boot/dtb-$version.old; fi" >> $pdir/DEBIAN/postinst
|
|
+ echo "ln -sf dtb-$version /boot/dtb > /dev/null 2>&1 || mv /boot/dtb-$version /boot/dtb" >> $pdir/DEBIAN/postinst
|
|
+ echo "exit 0" >> $pdir/DEBIAN/postinst
|
|
+ chmod 775 $pdir/DEBIAN/postinst
|
|
+ fi
|
|
+
|
|
+ # Create postinstall script for headers
|
|
+ if [[ "$1" == *headers* ]]; then
|
|
+ echo "cd /usr/src/linux-headers-$version; echo \"Compiling headers - please wait ...\"; find -type f -exec touch {} +;make -s scripts >/dev/null 2>&1" >> $pdir/DEBIAN/postinst
|
|
+ echo "exit 0" >> $pdir/DEBIAN/postinst
|
|
+ chmod 775 $pdir/DEBIAN/postinst
|
|
+ fi
|
|
+
|
|
# Create the package
|
|
dpkg-gencontrol -p$pname -P"$pdir"
|
|
dpkg --build "$pdir" ..
|
|
@@ -39,9 +60,11 @@ tmpdir="$objtree/debian/tmp"
|
|
kernel_headers_dir="$objtree/debian/hdrtmp"
|
|
libc_headers_dir="$objtree/debian/headertmp"
|
|
dbg_dir="$objtree/debian/dbgtmp"
|
|
-packagename=linux-image-$version
|
|
-kernel_headers_packagename=linux-headers-$version
|
|
-libc_headers_packagename=linux-libc-dev
|
|
+dtb_dir="$objtree/debian/dtbtmp"
|
|
+packagename=linux-image-dev"$LOCALVERSION"
|
|
+kernel_headers_packagename=linux-headers-dev"$LOCALVERSION"
|
|
+dtb_packagename=linux-dtb-dev"$LOCALVERSION"
|
|
+libc_headers_packagename=linux-libc-dev-dev"$LOCALVERSION"
|
|
dbg_packagename=$packagename-dbg
|
|
|
|
if [ "$ARCH" = "um" ] ; then
|
|
@@ -52,6 +75,15 @@ fi
|
|
# XXX: have each arch Makefile export a variable of the canonical image install
|
|
# path instead
|
|
case $ARCH in
|
|
+aarch64|arm64)
|
|
+ image_name=Image
|
|
+ installed_image_path="boot/vmlinuz-$version"
|
|
+
|
|
+ ;;
|
|
+arm*)
|
|
+ image_name=zImage
|
|
+ installed_image_path="boot/vmlinuz-$version"
|
|
+ ;;
|
|
um)
|
|
installed_image_path="usr/bin/linux-$version"
|
|
;;
|
|
@@ -65,7 +97,9 @@ esac
|
|
BUILD_DEBUG="$(grep -s '^CONFIG_DEBUG_INFO=y' $KCONFIG_CONFIG || true)"
|
|
|
|
# Setup the directory structure
|
|
-rm -rf "$tmpdir" "$kernel_headers_dir" "$libc_headers_dir" "$dbg_dir" $objtree/debian/files
|
|
+rm -rf "$tmpdir" "$kernel_headers_dir" "$libc_headers_dir" "$dbg_dir" "$dtb_dir" $objtree/debian/files
|
|
+mkdir -m 755 -p "$dtb_dir/DEBIAN"
|
|
+mkdir -p "$dtb_dir/boot/dtb-$version" "$dtb_dir/usr/share/doc/$dtb_packagename"
|
|
mkdir -m 755 -p "$tmpdir/DEBIAN"
|
|
mkdir -p "$tmpdir/lib" "$tmpdir/boot"
|
|
mkdir -p "$kernel_headers_dir/lib/modules/$version/"
|
|
@@ -118,6 +152,11 @@ if grep -q '^CONFIG_MODULES=y' $KCONFIG_CONFIG ; then
|
|
fi
|
|
fi
|
|
|
|
+if grep -q '^CONFIG_OF=y' $KCONFIG_CONFIG ; then
|
|
+ #mkdir -p "$tmpdir/boot/dtb"
|
|
+ INSTALL_DTBS_PATH="$dtb_dir/boot/dtb-$version" $MAKE KBUILD_SRC= dtbs_install
|
|
+fi
|
|
+
|
|
if [ "$ARCH" != "um" ]; then
|
|
$MAKE headers_check KBUILD_SRC=
|
|
$MAKE headers_install KBUILD_SRC= INSTALL_HDR_PATH="$libc_headers_dir/usr"
|
|
@@ -137,7 +176,7 @@ fi
|
|
for script in postinst postrm preinst prerm ; do
|
|
mkdir -p "$tmpdir$debhookdir/$script.d"
|
|
cat <<EOF > "$tmpdir/DEBIAN/$script"
|
|
-#!/bin/sh
|
|
+#!/bin/bash
|
|
|
|
set -e
|
|
|
|
@@ -153,9 +192,60 @@ EOF
|
|
chmod 755 "$tmpdir/DEBIAN/$script"
|
|
done
|
|
|
|
+##
|
|
+## Create sym link to kernel image
|
|
+##
|
|
+sed -e "s/set -e//g" -i $tmpdir/DEBIAN/postinst
|
|
+sed -e "s/exit 0//g" -i $tmpdir/DEBIAN/postinst
|
|
+cat >> $tmpdir/DEBIAN/postinst <<EOT
|
|
+if [ "\$(grep nand /proc/partitions)" != "" ] && [ "\$(grep mmc /proc/partitions)" = "" ]; then
|
|
+ mkimage -A arm -O linux -T kernel -C none -a "0x40008000" -e "0x40008000" -n "Linux kernel" -d /$installed_image_path /boot/uImage > /dev/null 2>&1
|
|
+ cp /boot/uImage /tmp/uImage
|
|
+ sync
|
|
+ mountpoint -q /boot || mount /boot
|
|
+ cp /tmp/uImage /boot/uImage
|
|
+ rm -f /$installed_image_path
|
|
+else
|
|
+ ln -sf $(basename $installed_image_path) /boot/$image_name || mv /$installed_image_path /boot/$image_name
|
|
+fi
|
|
+touch /boot/.next
|
|
+exit 0
|
|
+EOT
|
|
+
|
|
+##
|
|
+## FAT install workaround
|
|
+##
|
|
+sed -e "s/set -e//g" -i $tmpdir/DEBIAN/preinst
|
|
+sed -e "s/exit 0//g" -i $tmpdir/DEBIAN/preinst
|
|
+cat >> $tmpdir/DEBIAN/preinst <<EOT
|
|
+# exit if we are running chroot
|
|
+if [ "\$(stat -c %d:%i /)" != "\$(stat -c %d:%i /proc/1/root/.)" ]; then exit 0; fi
|
|
+
|
|
+check_and_unmount (){
|
|
+ boot_device=\$(mountpoint -d /boot)
|
|
+
|
|
+ for file in /dev/* ; do
|
|
+ CURRENT_DEVICE=\$(printf "%d:%d" \$(stat --printf="0x%t 0x%T" \$file))
|
|
+ if [[ "\$CURRENT_DEVICE" = "\$boot_device" ]]; then
|
|
+ boot_partition=\$file
|
|
+ break
|
|
+ fi
|
|
+ done
|
|
+
|
|
+ bootfstype=\$(blkid -s TYPE -o value \$boot_partition)
|
|
+ if [ "\$bootfstype" = "vfat" ]; then
|
|
+ umount /boot
|
|
+ rm -f /boot/System.map* /boot/config* /boot/vmlinuz* /boot/$image_name /boot/uImage
|
|
+ fi
|
|
+}
|
|
+mountpoint -q /boot && check_and_unmount
|
|
+EOT
|
|
+echo "exit 0" >> $tmpdir/DEBIAN/preinst
|
|
+
|
|
# Build kernel header package
|
|
(cd $srctree; find . -name Makefile\* -o -name Kconfig\* -o -name \*.pl) > "$objtree/debian/hdrsrcfiles"
|
|
(cd $srctree; find arch/*/include include scripts -type f -o -type l) >> "$objtree/debian/hdrsrcfiles"
|
|
+(cd $srctree; find security/*/include -type f) >> "$objtree/debian/hdrsrcfiles"
|
|
(cd $srctree; find arch/$SRCARCH -name module.lds -o -name Kbuild.platforms -o -name Platform) >> "$objtree/debian/hdrsrcfiles"
|
|
(cd $srctree; find $(find arch/$SRCARCH -name include -o -name scripts -type d) -type f) >> "$objtree/debian/hdrsrcfiles"
|
|
if grep -q '^CONFIG_STACK_VALIDATION=y' $KCONFIG_CONFIG ; then
|
|
@@ -167,15 +257,19 @@ if grep -q '^CONFIG_GCC_PLUGINS=y' $KCONFIG_CONFIG ; then
|
|
fi
|
|
destdir=$kernel_headers_dir/usr/src/linux-headers-$version
|
|
mkdir -p "$destdir"
|
|
+(cd $destdir; patch -p1 < /tmp/headers-debian-byteshift.patch)
|
|
(cd $srctree; tar -c -f - -T -) < "$objtree/debian/hdrsrcfiles" | (cd $destdir; tar -xf -)
|
|
(cd $objtree; tar -c -f - -T -) < "$objtree/debian/hdrobjfiles" | (cd $destdir; tar -xf -)
|
|
(cd $objtree; cp $KCONFIG_CONFIG $destdir/.config) # copy .config manually to be where it's expected to be
|
|
ln -sf "/usr/src/linux-headers-$version" "$kernel_headers_dir/lib/modules/$version/build"
|
|
rm -f "$objtree/debian/hdrsrcfiles" "$objtree/debian/hdrobjfiles"
|
|
|
|
+(cd $destdir; make M=scripts clean)
|
|
+
|
|
if [ "$ARCH" != "um" ]; then
|
|
create_package "$kernel_headers_packagename" "$kernel_headers_dir"
|
|
- create_package "$libc_headers_packagename" "$libc_headers_dir"
|
|
+ # create_package "$libc_headers_packagename" "$libc_headers_dir"
|
|
+ create_package "$dtb_packagename" "$dtb_dir"
|
|
fi
|
|
|
|
create_package "$packagename" "$tmpdir"
|
|
diff --git a/scripts/package/mkdebian b/scripts/package/mkdebian
|
|
index 6adb3a1..00e12eb 100755
|
|
--- a/scripts/package/mkdebian
|
|
+++ b/scripts/package/mkdebian
|
|
@@ -61,10 +61,12 @@ else
|
|
packageversion=$version-$revision
|
|
fi
|
|
sourcename=$KDEB_SOURCENAME
|
|
-packagename=linux-image-$version
|
|
-kernel_headers_packagename=linux-headers-$version
|
|
+packagename=linux-image-dev$LOCALVERSION
|
|
+kernel_headers_packagename=linux-headers-dev$LOCALVERSION
|
|
+dtb_packagename=linux-dtb-dev$LOCALVERSION
|
|
dbg_packagename=$packagename-dbg
|
|
debarch=
|
|
+image_name=
|
|
set_debarch
|
|
|
|
if [ "$ARCH" = "um" ] ; then
|
|
@@ -168,6 +170,11 @@ Architecture: $debarch
|
|
Description: Linux kernel debugging symbols for $version
|
|
This package will come in handy if you need to debug the kernel. It provides
|
|
all the necessary debug symbols for the kernel and its modules.
|
|
+
|
|
+Package: $dtb_packagename
|
|
+Architecture: $debarch
|
|
+Description: Linux DTB, version $version
|
|
+ This package contains device blobs from the Linux kernel, version $version
|
|
EOF
|
|
|
|
cat <<EOF > debian/rules
|
|
diff --git a/arch/arm64/Makefile b/arch/arm64/Makefile
|
|
index f839ecd9..cd276162 100644
|
|
--- a/arch/arm64/Makefile
|
|
+++ b/arch/arm64/Makefile
|
|
@@ -103,7 +103,7 @@ core-$(CONFIG_EFI_STUB) += $(objtree)/drivers/firmware/efi/libstub/lib.a
|
|
|
|
# Default target when executing plain make
|
|
boot := arch/arm64/boot
|
|
-KBUILD_IMAGE := $(boot)/Image.gz
|
|
+KBUILD_IMAGE := $(boot)/Image
|
|
|
|
all: Image.gz $(KBUILD_DTBS)
|
|
|